/*
   Hoarescope - Use Hoare logic for program correctness proofs
   Copyright (C) 2004 Markus Triska

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA

   Contact me at triska@gmx.at
*/



typedef enum { typeCon, typeId, typeOpr } nodeEnum;

struct conNodeType {
	nodeEnum type;
	int value;
};

struct idNodeType {
	nodeEnum type;
	char *str;
};

struct oprNodeType {
	nodeEnum type;
	int oper;
	int nops;
	union nodeTypeTag **op;
};

typedef union nodeTypeTag {
	nodeEnum type;
	struct conNodeType con;
	struct idNodeType id;
	struct oprNodeType opr;
} nodeType;

